//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TTreeView̃XN[o[̗LƖ\
//  TTreeView̃XN[o[ɕ\Ăꍇp
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2015N0727 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UPS1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StdCtrls, ComCtrls, CommCtrl;

type
  TplTreeView = class(TTreeView)
  private
    procedure Available_Disable_ScrollBars;
  protected
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure CNNotify(var Message: TWMNotifyTV); message CN_NOTIFY;
    procedure Added(Node: TTreeNode); override;
    procedure Resize; override;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    TreeView1: TTreeView;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    plTreeView1 : TplTreeView;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plChgCompo;

{$R *.dfm}

//=============================================================================
//  tH[OnCreateCxg
//  TTreeView̔hNX(R|[lg)𐶐
//  ɃeXgł悤ɃeXgp̃f[^Zbg
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  i      : Integer;
  j      : Integer;
  k      : Integer;
  LText1 : String;
  LText2 : String;
  LNode1 : TTreeNode;
  LNode2 : TTreeNode;
begin
  //tH[쐬ɃR|[lg̓ւ
  plTreeView1 := TplTreeView(ChangeComponent(TreeView1, TplTreeView));

  plTreeView1.Items.BeginUpdate;

  for i := 0 to 2 do begin
    LText1 := Format('%.5d',[i + 1]);
    LNode1 := plTreeView1.Items.Add(nil, LText1);
    for j := 0 to 2 do begin
      LText2 := LText1 + '-' + Format('%.5d',[j + 1]);
      LNode2 := plTreeView1.Items.AddChild(LNode1, LText2);
      if i = 2 then begin
        for k := 0 to 2 do begin
          plTreeView1.Items.AddChild(LNode2, LText2 + '-' + Format('%.15d',[k + 1]));
        end;
      end;
    end;
  end;

  plTreeView1.FullExpand;
  plTreeView1.Items.EndUpdate;

  LNode1 := plTreeView1.Items.GetFirstNode;
  LNode1.MakeVisible;
  LNode1.Selected := True;
end;

{ TplTreeView }

//-----------------------------------------------------------------------------
//  XN[o[̗L\Ɩ\̐p\bh
//-----------------------------------------------------------------------------
procedure TplTreeView.Available_Disable_ScrollBars;
var
  LScrollInfo : TScrollInfo;
begin
  LScrollInfo.cbSize := SizeOf(LScrollInfo);
  LScrollInfo.fMask  := SIF_ALL;

  //XN[o[̗L\C\̏
  GetScrollInfo(Handle, SB_VERT, LScrollInfo);
  if LScrollInfo.nMax > 0 then begin
    EnableScrollBar(Handle, SB_VERT, ESB_ENABLE_BOTH);
  end else begin
    EnableScrollBar(Handle, SB_VERT, ESB_DISABLE_BOTH);
  end;

  //XN[o[̗L\C\̏
  GetScrollInfo(Handle, SB_HORZ, LScrollInfo);
  if LScrollInfo.nMax > 0 then begin
    EnableScrollBar(Handle, SB_HORZ, ESB_ENABLE_BOTH);
  end else begin
    EnableScrollBar(Handle, SB_HORZ, ESB_DISABLE_BOTH);
  end;
end;

//=============================================================================
//  Resize\bh
//  Rg[TCYƎIɎs郁\bh
//=============================================================================
procedure TplTreeView.Resize;
begin
  inherited;
  Available_Disable_ScrollBars;
end;

//=============================================================================
//  Added\bh
//  m[hǉꂽɎIɎs郁\bh
//=============================================================================
procedure TplTreeView.Added(Node: TTreeNode);
begin
  inherited;
  Available_Disable_ScrollBars;
end;

//=============================================================================
//  CN_NOTIFYbZ[W
//  TVN_XXXCN_NOTIFYbZ[WŎMł
//  CN_NOTIFŸ̌^́CR[h⊮@\gpTMessage^ƂȂ
//  TWMNotifyTV^ɕύXĎgp
//
//  TVN_XXX̎gpɂusesCommCtrlKv
//=============================================================================
procedure TplTreeView.CNNotify(var Message: TWMNotifyTV);
var
  LCode : Integer;
begin
  inherited;

  LCode := Message.NMHdr.code;
  case LCode of
    TVN_ENDLABELEDIT,
    TVN_DELETEITEM,
    TVN_ITEMEXPANDED:
    begin
      Available_Disable_ScrollBars;
    end;
  end;
end;

//=============================================================================
//  WM_NCCALCSIZEbZ[W
//  XN[o[\̃tOIɕύX
//=============================================================================
procedure TplTreeView.WMNCCalcSize(var Message: TWMNCCalcSize);
var
  LStyle : Integer;
begin
  LStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWindowLong(Handle, GWL_STYLE, LStyle or WS_HSCROLL or WS_VSCROLL);

  inherited;
end;

end.
